summaryrefslogtreecommitdiffstats
path: root/ansible
diff options
context:
space:
mode:
authorPetr Ospalý <p.ospaly@partner.samsung.com>2018-12-19 12:47:27 +0100
committerPetr Ospalý <p.ospaly@partner.samsung.com>2018-12-19 12:51:36 +0100
commit6b44f821637c1edfc0b4a9a74fa8430a0c3a46ba (patch)
treee205acb0af8c95ed73ef5379634851bf4f0462c7 /ansible
parentd21977bd82508b90c8bfda24111ac4a693256e70 (diff)
Add ansible docker image
Dockerfile and script for building the image Change-Id: If1e83095463ae209e284ba92898447a1205a2244 Issue-ID: OOM-1551 Signed-off-by: Petr Ospalý <p.ospaly@partner.samsung.com>
Diffstat (limited to 'ansible')
-rw-r--r--ansible/docker/Dockerfile34
-rwxr-xr-xansible/docker/build_ansible_image.sh52
2 files changed, 86 insertions, 0 deletions
diff --git a/ansible/docker/Dockerfile b/ansible/docker/Dockerfile
new file mode 100644
index 00000000..b0172709
--- /dev/null
+++ b/ansible/docker/Dockerfile
@@ -0,0 +1,34 @@
+FROM alpine:3.8
+
+ARG ansible_version=2.6.3
+LABEL ansible_version=$ansible_version vendor=Samsung
+
+# Install Ansible build dependencies
+RUN apk --no-cache update \
+&& apk --no-cache --update add --virtual build-dependencies \
+ gcc \
+ make \
+ musl-dev \
+ libffi-dev \
+ openssl-dev \
+ python3-dev \
+&& apk add --no-cache \
+ python3 \
+ py3-pip \
+ openssh-client \
+ openssl \
+ py3-openssl \
+ openssh \
+ sshpass \
+&& pip3 install --no-cache-dir --upgrade pip \
+&& pip3 install --no-cache-dir \
+ ansible==$ansible_version \
+ jmespath \
+&& apk del build-dependencies && rm -rf /var/cache/apk/*
+
+ENV ANSIBLE_HOST_KEY_CHECKING false
+ENV ANSIBLE_RETRY_FILES_ENABLED false
+
+WORKDIR /ansible
+
+ENTRYPOINT ["ansible-playbook"]
diff --git a/ansible/docker/build_ansible_image.sh b/ansible/docker/build_ansible_image.sh
new file mode 100755
index 00000000..d54ddc43
--- /dev/null
+++ b/ansible/docker/build_ansible_image.sh
@@ -0,0 +1,52 @@
+#! /usr/bin/env bash
+
+# COPYRIGHT NOTICE STARTS HERE
+
+# Copyright 2018 © Samsung Electronics Co., Ltd.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# COPYRIGHT NOTICE ENDS HERE
+
+
+set -e
+
+ansible_version="$1"
+image_name="${2:-ansible:latest}"
+
+script_path=$(readlink -f "$0")
+script_dir=$(dirname "$script_path")
+
+git_commit=$(git rev-parse --revs-only HEAD)
+build_date=$(date -I)
+
+if [ -z "$ansible_version" ]; then
+ docker build "$script_dir" -t "${image_name}" --label "git-commit=$git_commit" --label "build-date=$build_date"
+else
+ docker build "$script_dir" -t "${image_name}" --label "git-commit=$git_commit" --label "build-date=$build_date" --build-arg ansible_version="$ansible_version"
+fi
+
+# Export docker image into chroot and tararchive it. It takes ~40M of space and is packaged together with sw.
+if "${script_dir}"/create_docker_chroot.sh convert "${image_name}" "${script_dir}"/ansible_chroot ; then
+ cd "$script_dir"
+ echo INFO: "Tarring and zipping the chroot directory..." >&2
+ tar -czf ansible_chroot.tgz ansible_chroot
+ rm -rf "${script_dir}"/ansible_chroot
+ echo INFO: "Finished: ${script_dir}/ansible_chroot.tgz" >&2
+ cd -
+else
+ echo ERROR: "I failed to create a chroot environment" >&2
+ exit 1
+fi
+
+exit 0 \ No newline at end of file